### Virtual Method

# Camel Service authenticate_sync

since: 3.4

#### Declaration [src]

    CamelAuthenticationResult
    authenticate_sync (
      CamelService* service,
      const gchar* mechanism,
      GCancellable* cancellable,
      GError** error
    )

#### Description [src]

Attempts to authenticate `service` using `mechanism` and, if necessary, `service`‘s `CamelService:password` property. The function makes only ONE attempt at authentication and does not loop.

If the authentication attempt completed and the server accepted the credentials, the function returns #CAMEL_AUTHENTICATION_ACCEPTED.

If the authentication attempt completed but the server rejected the credentials, the function returns #CAMEL_AUTHENTICATION_REJECTED.

If the authentication attempt failed to complete due to a network communication issue or some other mishap, the function sets `error` and returns #CAMEL_AUTHENTICATION_ERROR.

Generally this function should only be called from a `CamelSession` subclass in order to implement its own authentication loop.

Available since: 3.4

#### Parameters

`mechanism`

  Type: `const gchar*`

  A SASL mechanism name, or `NULL`.

  The argument can be `NULL`.
  The data is owned by the caller of the method.
  The value is a NUL terminated UTF-8 string.

`cancellable`

  Type: `GCancellable`

  Optional `GCancellable` object, or `NULL`.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the virtual function if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `CamelAuthenticationResult`

The authentication result.